{$mode objfpc}{$h+}{$assertions on}{$R+}
uses Math;

var
  f: array of String;
  w, h: Integer;

function IsStable(x, y: Integer): Boolean;
begin
  Result :=
    (y = h - 1) or (f[y][x] = '.') or (f[y + 1][x] = 'O') or
    InRange(x, 2, w - 1) and (f[y][x - 1] <> '.') and (f[y][x + 1] <> '.');
end;

var
  x, y: Integer;
  stable: Boolean;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Readln(w, h);
  Assert(InRange(w, 1, 1000) and InRange(h, 1, 1000));
  SetLength(f, h);
  for y := 0 to h - 1 do
    Readln(f[y]);
  repeat
    stable := true;
    for y := 0 to h - 1 do
      for x := 1 to w do
        if not IsStable(x, y) then begin
          stable := false;
          f[y][x] := '.';
        end;
  until stable;
  for y := 0 to h - 1 do
    Writeln(f[y]);
end.
