#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXK = -1;
const int MAXN = -1;



int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n, m;
	while (cin >> m >> n) {
		vector<string> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			a[i] = "." + a[i] + ".";
		}

		for (int i = n - 2; i >= 0; i--) {
			bool changed = 1;
			while (changed) {
				changed = 0;
				for (int j = 1; j <= m; j++) {
					bool stable = 0;
					stable |= a[i + 1][j] == 'O';
					stable |= a[i][j - 1] != '.' && a[i][j + 1] != '.';
					if (!stable) changed |= a[i][j] != '.', a[i][j] = '.';
				}
				for (int j = m; j >= 1; j--) {
					bool stable = 0;
					stable |= a[i + 1][j] == 'O';
					stable |= a[i][j - 1] != '.' && a[i][j + 1] != '.';
					if (!stable) changed |= a[i][j] != '.', a[i][j] = '.';
				}
			}
		}
		for (int i = 0; i < n; i++) cout << a[i].substr(1, m) << endl;
	}
	
	return 0;
}
